/*
; copystring.c
;
; Demonstracny program v jazyku C pre kopirovanie ASCII retazcov  
; do vnutornej RAM
; Dlzka retazca kontrolovana koncovym znakom 00H (v jazyku C
; dodany automaticky vzdy na konci retazca)
;
;
;	
; Opis:
;
; Program postupne kopiruje tri rozne retazce do internej RAM:
; ASCII retazec AS1 je ulozeny v externej pamati dat,
; ASCII retazec AS2 je ulozeny v pamati programu,
; ASCII retazec AS3 je ulozeny v internej pameti dat
;  
; retazce sa skopiruju do buffra AD vo vnutornej RAM.
;
*/


#include <string.h>

// definicie

xdata volatile char AS1[]= "12345678"; //"PRVY RETAZEC"; // retazec v externej pameti dat
code char AS2[] = "DRUHY RETAZEC";         // retazec v pameti programu
char AS3[] = "TRETI RETAZEC";		       // retazec v internej pameti dat


char AD	[20]; // CIELOVA ADRESA BLOKU DAT (interna pamet)


//----------------------------------------------
// HLAVNY PROGRAM
//----------------------------------------------	

void main (void)
{

 strcpy(AD,AS1); // kopirovanie z externej pamete

 strcpy(AD,AS2); // kopirovanie z pamete programu

 strcpy(AD,AS3); // kopirovanie z internej pamete

 while(1);       // nekonecna slucka
}

	





